Apply studio order refund
Requires refunds:write. Explicit exact confirmation and financial revision required. Pre-syncs Stripe, rechecks role/grant/balance and uses existing refund request/approval/execution engine. Accepted is not succeeded. Retry the same key/preview after interruption. No provider cancellation.
curl --request POST \
--url https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"confirmed": true,
"expected_financial_revision": "<string>",
"preview_id": "<string>"
}
'import requests
url = "https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests"
payload = {
"confirmed": True,
"expected_financial_revision": "<string>",
"preview_id": "<string>"
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
confirmed: true,
expected_financial_revision: '<string>',
preview_id: '<string>'
})
};
fetch('https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'confirmed' => true,
'expected_financial_revision' => '<string>',
'preview_id' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests"
payload := strings.NewReader("{\n \"confirmed\": true,\n \"expected_financial_revision\": \"<string>\",\n \"preview_id\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"confirmed\": true,\n \"expected_financial_revision\": \"<string>\",\n \"preview_id\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"confirmed\": true,\n \"expected_financial_revision\": \"<string>\",\n \"preview_id\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"amount_cents": 123,
"blockers": [
"<string>"
],
"created_at": 123,
"currency": "<string>",
"customer_id": "<string>",
"environment": "<string>",
"execution_required": true,
"id": "<string>",
"order_id": "<string>",
"preview_id": "<string>",
"simulated": true,
"status": "<string>",
"studio_id": "<string>"
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}Authorizations
Batch Relay scoped API key or an anonymous Test Mode session. Scope names document required capabilities. Anonymous sessions are sandbox-only and do not authorize studio, event, billing, or Live Mode operations.
Headers
Original delegated Clerk OAuth bearer. Go independently verifies signature/current revocation, exact resource audience, allowed OAuth client and action scope. Caller must match attributed API key creator. Never send an unverified subject header.
Durable exact refund preview/request identity. Repeat unchanged after interruption.
16 - 80^[A-Za-z0-9_-]{16,80}$Untrusted optional analytics hint naming the calling client surface. It never affects authorization, routing, pricing, or behavior.
1 - 100Untrusted optional analytics hint naming the calling client version. It never affects authorization, routing, pricing, or behavior.
1 - 100Untrusted optional analytics hint naming the invocation mode. It never affects authorization, routing, pricing, or behavior.
1 - 100Path Parameters
Opaque public studio_id. Private Convex IDs are rejected.
Body
Response
Authoritative Studio result
curl --request POST \
--url https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"confirmed": true,
"expected_financial_revision": "<string>",
"preview_id": "<string>"
}
'import requests
url = "https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests"
payload = {
"confirmed": True,
"expected_financial_revision": "<string>",
"preview_id": "<string>"
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
confirmed: true,
expected_financial_revision: '<string>',
preview_id: '<string>'
})
};
fetch('https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'confirmed' => true,
'expected_financial_revision' => '<string>',
'preview_id' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests"
payload := strings.NewReader("{\n \"confirmed\": true,\n \"expected_financial_revision\": \"<string>\",\n \"preview_id\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"confirmed\": true,\n \"expected_financial_revision\": \"<string>\",\n \"preview_id\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.batchrelay.com/v1/studios/{studio_id}/refund-requests")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"confirmed\": true,\n \"expected_financial_revision\": \"<string>\",\n \"preview_id\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"amount_cents": 123,
"blockers": [
"<string>"
],
"created_at": 123,
"currency": "<string>",
"customer_id": "<string>",
"environment": "<string>",
"execution_required": true,
"id": "<string>",
"order_id": "<string>",
"preview_id": "<string>",
"simulated": true,
"status": "<string>",
"studio_id": "<string>"
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}